"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LruCache = void 0;
var tslib_1 = require("tslib");
var lru_map_1 = tslib_1.__importDefault(require("collections/lru-map"));
var LruCache = (function () {
    function LruCache(size) {
        this.map = new lru_map_1.default({}, size);
    }
    LruCache.prototype.read = function (key) {
        var _a;
        return Promise.resolve((_a = this.map.get(key)) !== null && _a !== void 0 ? _a : null);
    };
    LruCache.prototype.write = function (key, value) {
        this.map.set(key, value);
        return Promise.resolve();
    };
    LruCache.prototype.flush = function () {
        this.map.clear();
        return Promise.resolve();
    };
    return LruCache;
}());
exports.LruCache = LruCache;
//# sourceMappingURL=LruCache.js.map