"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Memcached = void 0;
var tslib_1 = require("tslib");
var memcached_1 = tslib_1.__importDefault(require("memcached"));
var Memcached = (function () {
    function Memcached(address, lifetime) {
        if (address === void 0) { address = "127.0.0.0:11211"; }
        if (lifetime === void 0) { lifetime = 10; }
        this.client = new memcached_1.default(address);
        this.lifetime = lifetime;
    }
    Memcached.prototype.read = function (key) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this.client.get(key, function (err, data) {
                if (err) {
                    reject(err);
                }
                else {
                    resolve(data !== null && data !== void 0 ? data : null);
                }
            });
        });
    };
    Memcached.prototype.write = function (key, value) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this.client.set(key, value, _this.lifetime, function (err) {
                if (err) {
                    reject(err);
                }
                else {
                    resolve();
                }
            });
        });
    };
    Memcached.prototype.flush = function () {
        var _this = this;
        return new Promise(function (resolve) {
            _this.client.flush(function () {
                resolve();
            });
        });
    };
    return Memcached;
}());
exports.Memcached = Memcached;
//# sourceMappingURL=Memcached.js.map