import { PrismaClient } from "@prisma/client";
export interface Cache {
    read: (key: string) => Promise<string | null>;
    write: (key: string, value: string) => Promise<void>;
    flush: () => Promise<void>;
}
export interface SingletonClient {
    cache?: Cache;
    client?: PrismaClient;
}
export declare const PureActions: string[];
export declare const ImpureActions: string[];
export declare class Prisma {
    private static singleton;
    cache: Cache;
    client: PrismaClient;
    constructor();
    static cacheFactory: () => Cache;
    private static clientFactory;
}
