"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Prisma = exports.ImpureActions = exports.PureActions = void 0;
var tslib_1 = require("tslib");
var LruCache_1 = require("./LruCache");
var client_1 = require("@prisma/client");
exports.PureActions = [
    "aggregate",
    "count",
    "findFirst",
    "findMany",
    "findUnique",
    "queryRaw",
];
exports.ImpureActions = [
    "create",
    "createMany",
    "delete",
    "deleteMany",
    "executeRaw",
    "update",
    "updateMany",
    "upsert",
];
var Prisma = (function () {
    function Prisma() {
        if (!Prisma.singleton.cache) {
            Prisma.singleton.cache = Prisma.cacheFactory();
        }
        if (!Prisma.singleton.client) {
            Prisma.singleton.client = Prisma.clientFactory();
        }
        this.client = Prisma.singleton.client;
        this.cache = Prisma.singleton.cache;
    }
    Prisma.clientFactory = function () {
        var e_1, _a;
        var _this = this;
        var client = new client_1.PrismaClient();
        var _loop_1 = function (field) {
            var e_2, _d, e_3, _e;
            var _loop_2 = function (action) {
                var pristine = client[field][action];
                client[field][action] = function () {
                    var _a;
                    var args = [];
                    for (var _i = 0; _i < arguments.length; _i++) {
                        args[_i] = arguments[_i];
                    }
                    (_a = Prisma.singleton.cache) === null || _a === void 0 ? void 0 : _a.flush();
                    return pristine.apply(void 0, tslib_1.__spreadArray([], tslib_1.__read(args), false));
                };
            };
            try {
                for (var ImpureActions_1 = (e_2 = void 0, tslib_1.__values(exports.ImpureActions)), ImpureActions_1_1 = ImpureActions_1.next(); !ImpureActions_1_1.done; ImpureActions_1_1 = ImpureActions_1.next()) {
                    var action = ImpureActions_1_1.value;
                    _loop_2(action);
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (ImpureActions_1_1 && !ImpureActions_1_1.done && (_d = ImpureActions_1.return)) _d.call(ImpureActions_1);
                }
                finally { if (e_2) throw e_2.error; }
            }
            var _loop_3 = function (action) {
                var pristine = client[field][action];
                client[field][action] = function () {
                    var args = [];
                    for (var _i = 0; _i < arguments.length; _i++) {
                        args[_i] = arguments[_i];
                    }
                    return tslib_1.__awaiter(_this, void 0, void 0, function () {
                        var key, cached, evaluated;
                        var _a, _b;
                        return tslib_1.__generator(this, function (_c) {
                            switch (_c.label) {
                                case 0:
                                    key = JSON.stringify({ field: field, action: action, args: args });
                                    return [4, ((_a = Prisma.singleton.cache) === null || _a === void 0 ? void 0 : _a.read(key))];
                                case 1:
                                    cached = _c.sent();
                                    if (cached) {
                                        return [2, JSON.parse(cached)];
                                    }
                                    return [4, pristine.apply(void 0, tslib_1.__spreadArray([], tslib_1.__read(args), false))];
                                case 2:
                                    evaluated = _c.sent();
                                    return [4, ((_b = Prisma.singleton.cache) === null || _b === void 0 ? void 0 : _b.write(key, JSON.stringify(evaluated)))];
                                case 3:
                                    _c.sent();
                                    return [2, evaluated];
                            }
                        });
                    });
                };
            };
            try {
                for (var PureActions_1 = (e_3 = void 0, tslib_1.__values(exports.PureActions)), PureActions_1_1 = PureActions_1.next(); !PureActions_1_1.done; PureActions_1_1 = PureActions_1.next()) {
                    var action = PureActions_1_1.value;
                    _loop_3(action);
                }
            }
            catch (e_3_1) { e_3 = { error: e_3_1 }; }
            finally {
                try {
                    if (PureActions_1_1 && !PureActions_1_1.done && (_e = PureActions_1.return)) _e.call(PureActions_1);
                }
                finally { if (e_3) throw e_3.error; }
            }
        };
        try {
            for (var _b = tslib_1.__values(Object.getOwnPropertyNames(client).filter(function (property) {
                return !property.startsWith("$") && !property.startsWith("_");
            })), _c = _b.next(); !_c.done; _c = _b.next()) {
                var field = _c.value;
                _loop_1(field);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return client;
    };
    Prisma.singleton = {};
    Prisma.cacheFactory = function () { return new LruCache_1.LruCache(100); };
    return Prisma;
}());
exports.Prisma = Prisma;
//# sourceMappingURL=prisma.js.map